package org.nuiton.topia.security.entities.authorization;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaSecurityDAOHelper.TopiaSecurityEntityEnum;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class TopiaEntityAuthorizationDAOAbstract<E extends TopiaEntityAuthorization> extends TopiaAuthorizationDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)TopiaEntityAuthorization.class;
    }

    @Override
    public TopiaSecurityEntityEnum getTopiaEntityEnum() {
        return TopiaSecurityEntityEnum.TopiaEntityAuthorization;
    }

    public E findByExpression(String v) throws TopiaException {
        E result = findByProperty(TopiaEntityAuthorization.EXPRESSION, v);
        return result;
    }

    public List<E> findAllByExpression(String v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaEntityAuthorization.EXPRESSION, v);
        return result;
    }

    public E findByActions(int v) throws TopiaException {
        E result = findByProperty(TopiaEntityAuthorization.ACTIONS, v);
        return result;
    }

    public List<E> findAllByActions(int v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaEntityAuthorization.ACTIONS, v);
        return result;
    }

    public E findByPrincipals(Set v) throws TopiaException {
        E result = findByProperty(TopiaEntityAuthorization.PRINCIPALS, v);
        return result;
    }

    public List<E> findAllByPrincipals(Set v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaEntityAuthorization.PRINCIPALS, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //TopiaEntityAuthorizationDAOAbstract<E extends TopiaEntityAuthorization>
