package org.nuiton.topia.security.entities.authorization;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaSecurityDAOHelper.TopiaSecurityEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class TopiaExpressionLinkDAOAbstract<E extends TopiaExpressionLink> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)TopiaExpressionLink.class;
    }

    @Override
    public TopiaSecurityEntityEnum getTopiaEntityEnum() {
        return TopiaSecurityEntityEnum.TopiaExpressionLink;
    }

    public E findByReplace(String v) throws TopiaException {
        E result = findByProperty(TopiaExpressionLink.REPLACE, v);
        return result;
    }

    public List<E> findAllByReplace(String v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaExpressionLink.REPLACE, v);
        return result;
    }

    public E findByBy(String v) throws TopiaException {
        E result = findByProperty(TopiaExpressionLink.BY, v);
        return result;
    }

    public List<E> findAllByBy(String v) throws TopiaException {
        List<E> result = findAllByProperty(TopiaExpressionLink.BY, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //TopiaExpressionLinkDAOAbstract<E extends TopiaExpressionLink>
