package org.nuiton.topia.taas.entities;

import java.util.Collection;
import java.util.Date;
import org.nuiton.topia.persistence.TopiaEntity;

public interface TaasUser extends TopiaEntity {

    String LOGIN = "login";

    String PASSWORD = "password";

    String EMAIL = "email";

    String ENABLED = "enabled";

    String LAST_CONNECTION_DATE = "lastConnectionDate";

    String NUMBER_OF_CONNECTION = "numberOfConnection";

    String LINK = "link";

    String PRINCIPALS = "principals";

    void setLogin(String login);

    String getLogin();

    void setPassword(String password);

    String getPassword();

    void setEmail(String email);

    String getEmail();

    void setEnabled(boolean enabled);

    boolean isEnabled();

    boolean getEnabled();

    void setLastConnectionDate(Date lastConnectionDate);

    Date getLastConnectionDate();

    void setNumberOfConnection(int numberOfConnection);

    int getNumberOfConnection();

    void setLink(String link);

    String getLink();

    void addPrincipals(TaasPrincipal principals);

    void addAllPrincipals(Collection<TaasPrincipal> principals);

    void setPrincipals(Collection<TaasPrincipal> principals);

    void removePrincipals(TaasPrincipal principals);

    void clearPrincipals();

    Collection<TaasPrincipal> getPrincipals();

    TaasPrincipal getPrincipalsByTopiaId(String topiaId);

    int sizePrincipals();

    boolean isPrincipalsEmpty();

} //TaasUser
